/*
 * This software is the confidential and proprietary information of
 * Smardec. You shall not disclose or distribute such Confidential Information.
 * This software shall not be integrated, copied (partially or fully),
 * or reverse engineered into any other software, program, or code that is
 * not intended for Smardec. You shall use it only in accordance with the terms
 * of the license agreement you entered into with Smardec.
 *
 * Copyright (C) 2004-2006 Smardec. All rights reserved.
 *
 * http://www.smardec.com
 *
 */

package com.smardec.demo.j2native.linux.usermanager;

import com.smardec.demo.j2native.linux.usermanager.info.GroupInfo;
import com.smardec.demo.j2native.linux.usermanager.j2n.InfoProvider;
import com.smardec.demo.j2native.tools.Cache;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class GroupManager {
    private static GroupManager instance;
    private Cache userGroups;

    private GroupManager() {
        userGroups = new Cache();
    }

    public static GroupManager getInstance() {
        if (instance == null) {
            instance = new GroupManager();
        }
        return instance;
    }

    public GroupInfo getGroupInfo(int id) {
        return GroupInfo.clone((GroupInfo) userGroups.get(new Integer(id)));
    }

    public GroupInfo getGroupInfo(String userName) {
        return GroupInfo.clone((GroupInfo) userGroups.get(userName));
    }

    public GroupInfo[] getGroupInfos() {
        List infosList = new ArrayList();
        Iterator iterator = userGroups.iterator();
        while (iterator.hasNext()) {
            GroupInfo gi = (GroupInfo) iterator.next();
            if (gi != null) {
                infosList.add(GroupInfo.clone((GroupInfo) gi));
            }
        }
        return (GroupInfo[]) infosList.toArray(new GroupInfo[infosList.size()]);
    }

    public boolean setGroupInfo(GroupInfo GroupInfo) {
        return false;
    }

    public void refresh() {
        userGroups.clear();
        InfoProvider infoProvider = InfoProvider.getInfoProvider();
        List groups = infoProvider.getAllGroups();
        for (int i = groups.size() - 1; i >= 0; i--) {
            GroupInfo groupInfo = (GroupInfo) groups.get(i);
            userGroups.put(new Integer(groupInfo.getId()), groupInfo);
            userGroups.put(groupInfo.getGroupName(), groupInfo);
        }
    }
}


